.Backroom {
  --BackroomBlue: #008aff;
  --BackroomBlueBackground: #a7defe;
  --BackroomBlueText: #1a7acc;
  --BackroomGreen: #13d12e;
  --BackroomGreenBackground: #9af6ad;
  --BackroomGreenText: #0da623;
  --BackroomOrange: #ff9c00;
  --BackroomOrangeBackground: #ffcc7b;
  --BackroomOrangeText: #d06c05;
  --BackroomRed: #ff2828;
  --BackroomRedBackground: #ffaaaa;
  --BackroomRedText: #cb0707;
  --BackroomGrey0: #ffffff;
  --BackroomGrey1: #f7f7f7;
  --BackroomGrey2: #efefef;
  --BackroomGrey3: #dfdfdf;
  --BackroomGrey4: #cfcfcf;
  --BackroomGrey5: #bfbfbf;
  --BackroomGrey6: #9f9f9f;
  --BackroomGrey7: #7f7f7f;
  --BackroomGrey8: #5f5f5f;
  --BackroomGrey9: #3f3f3f;
  --BackroomGrey10: #1f1f1f;
  --BackroomGrey11: #000000;
  overflow-y: scroll;
  --scrollbarWidth: 0px;
}
.Backroom--dark {
  --BackroomBlue: #4a85ba;
  --BackroomGreen: #8ac950;
  --BackroomOrange: #de7b28;
  --BackroomRed: #c53e3e;
  --BackroomGrey11: #efefef;
  --BackroomGrey10: #bfbfbf;
  --BackroomGrey9: #b7b7b7;
  --BackroomGrey8: #a7a7a7;
  --BackroomGrey7: #979797;
  --BackroomGrey6: #878787;
  --BackroomGrey5: #777777;
  --BackroomGrey4: #676767;
  --BackroomGrey3: #575757;
  --BackroomGrey2: #474747;
  --BackroomGrey1: #3f3f3f;
  --BackroomGrey0: #2a2a2a;
}

@font-face {
  font-family: "Font Awesome 6 Free";
  font-style: normal;
  font-weight: 900;
  font-display: block;
  src: url("../fonts/fa-solid-900.woff2") format("woff2");
}
.Backroom {
  background: var(--BackroomGrey0);
}

.Backroom--hasOverlay {
  overflow: hidden;
  padding-right: var(--scrollbarWidth);
}

.Backroom__elem--disabled {
  opacity: 0.5;
  pointer-events: none;
}

.Backroom__elem--hidden {
  display: none !important;
}

.Backroom__elem--strikethrough {
  text-decoration: line-through;
}

.Backroom__Icon {
  font-family: "Font Awesome 6 Free", fantasy;
}
.Backroom__Icon--blue {
  color: var(--BackroomBlue);
}
.Backroom__Icon--green {
  color: var(--BackroomGreen);
}
.Backroom__Icon--orange {
  color: var(--BackroomOrange);
}
.Backroom__Icon--red {
  color: var(--BackroomRed);
}
.Backroom__Icon--grey {
  color: var(--BackroomGrey8);
}

.Backroom__Icon--square {
  height: 1em;
  width: 1em;
  text-align: center;
  display: inline-block;
}

.Backroom__Form {
  margin: 1rem 0;
  max-width: 70rem;
}

.Backroom__Form input,
.Backroom__Form select,
.Backroom__Form textarea {
  background: var(--BackroomGrey0);
  border: 1px solid var(--BackroomGrey6);
  color: var(--BackroomGrey10);
  padding: 0.2rem 0.4rem;
}

.Backroom__Form select {
  box-sizing: border-box;
  padding: 0 0.2rem;
}

.Backroom__Form input:focus,
.Backroom__Form select:focus,
.Backroom__Form textarea:focus {
  border: 1px solid var(--BackroomGrey11);
  outline: none;
}

.Backroom__Form__Field + .Backroom__Form__Field {
  margin-top: 0.5rem;
  padding-top: 0.5rem;
  border-top: 1px solid var(--BackroomGrey1);
}

.Backroom__Form__Field--hidden {
  display: none;
}

.Backroom__Form__Field__Main {
  display: flex;
  align-items: flex-start;
  gap: 1rem;
}

.Backroom__Form__Field__Errors {
  margin-bottom: 0.5rem;
}

.Backroom__Form__Field__Label {
  width: 12rem;
  flex-shrink: 0;
}
.Backroom__Form__Field__Label label {
  display: inline-block;
  padding: 0.2rem 0.4rem 0.2rem 0;
}
.Backroom__Form__Field--has_errors .Backroom__Form__Field__Label label {
  color: var(--BackroomRed);
}

.Backroom__Form__Field__Input {
  flex-grow: 1;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}

.Backroom__Form__Tip {
  font-size: 0.7rem;
  color: var(--BackroomGrey8);
}

.Backroom__Form__Field__Empty {
  color: var(--BackroomGrey6);
}

.Backroom__Form__FieldType__Textarea textarea,
.Backroom__Form__FieldType__Json textarea.Backroom__Form__FieldType__Textarea--plain {
  height: 5rem;
  min-height: 2rem;
  width: 30rem;
  min-width: 30rem;
}

.Backroom__Form__FieldType__Code textarea {
  height: 20rem;
  min-height: 2rem;
  width: 100%;
  min-width: 30rem;
  box-sizing: border-box;
}

.Backroom__Form__FieldType__Json__Jsoneditor .jsoneditor {
  border-color: var(--BackroomGrey9);
  width: 30rem;
  max-width: 100%;
}

.Backroom__Form__FieldType__Code__AceEditor {
  position: relative;
  height: 30rem;
  min-width: 30rem;
  border: 1px solid var(--BackroomGrey9);
}

.Backroom__Form__FieldType__Records__Select {
  margin-top: 0.5rem;
  display: flex;
  align-items: center;
  gap: 0.5rem;
}

.Backroom__Form__FieldType__Button--right {
  display: flex;
  flex-grow: 1;
  justify-content: flex-end;
}

.Backroom__Form__FieldType__File input:focus,
.Backroom__Form__FieldType__File input {
  border: 0;
  width: 100%;
}

.Backroom__Form [data-touched="0"] {
  opacity: 0.5;
  background: var(--BackroomGrey1);
}

.Backroom__Flex {
  display: flex;
}

.Backroom__Flex--gap {
  gap: 0 1rem;
}

.Backroom__Flex--gap-half {
  gap: 0.5rem;
}

.Backroom__Flex--align-center {
  align-items: center;
}

.Backroom__Flex--wrap {
  flex-wrap: wrap;
}

.Backroom__Flex--column {
  flex-direction: column;
}

.Backroom__Message {
  position: relative;
  max-width: 800px;
  margin: 1rem 0;
  background-color: var(--BackroomGrey3);
  color: var(--BackroomGrey9);
  padding: 0.85rem 1rem 0.85rem 3.5rem;
}
.Backroom__Message + .Backroom__Message {
  margin-top: 0.5rem;
}
.Backroom__Message:after {
  font-family: "Font Awesome 6 Free", fantasy;
  font-size: 1.5rem;
  position: absolute;
  top: 0.75rem;
  left: 1rem;
  content: "\f249";
}
.Backroom__Message p {
  font-weight: bold;
}
.Backroom__Message p a {
  text-decoration: underline;
  text-decoration-thickness: 0.1rem;
  text-underline-offset: 0.1rem;
  filter: brightness(133%);
  color: inherit;
}
.Backroom__Message p + p {
  margin-top: 1rem;
}
.Backroom__Message--blue {
  background-color: var(--BackroomBlueBackground);
  color: var(--BackroomBlueText);
}
.Backroom__Message--blue p a {
  filter: brightness(66%);
}
.Backroom__Message--blue:after {
  content: "\f05a";
}
.Backroom__Message--green {
  background-color: var(--BackroomGreenBackground);
  color: var(--BackroomGreenText);
}
.Backroom__Message--green p a {
  filter: brightness(66%);
}
.Backroom__Message--green:after {
  content: "\f164";
}
.Backroom__Message--orange {
  background-color: var(--BackroomOrangeBackground);
  color: var(--BackroomOrangeText);
}
.Backroom__Message--orange p a {
  filter: brightness(66%);
}
.Backroom__Message--orange:after {
  content: "\f071";
}
.Backroom__Message--red {
  background-color: var(--BackroomRedBackground);
  color: var(--BackroomRedText);
}
.Backroom__Message--red p a {
  filter: brightness(66%);
}
.Backroom__Message--red:after {
  content: "\f06a";
}

.Backroom__Button {
  display: inline-flex;
  align-items: center;
  gap: 0.5em;
  border: 0;
  padding: 0.4em 0.8em 0.4em 0.9em;
  cursor: pointer;
  background: var(--BackroomGrey7);
  color: white;
  font-weight: bold;
  text-decoration: none;
  border-radius: 100rem;
  white-space: nowrap;
  letter-spacing: 1px;
  font-size: 1rem;
}
.Backroom__Button .Backroom__Icon {
  position: relative;
  transform: scale(125%);
  pointer-events: none;
}
.Backroom__Button--blue {
  background: var(--BackroomBlue);
}
.Backroom__Button--green {
  background: var(--BackroomGreen);
}
.Backroom__Button--orange {
  background: var(--BackroomOrange);
}
.Backroom__Button--red {
  background: var(--BackroomRed);
}
.Backroom__Button:hover {
  filter: grayscale(30%);
}
.Backroom__Button:active {
  transform: scale(95%);
}
.Backroom__Button--micro {
  font-size: 0.6rem;
}
.Backroom__Button--tiny {
  font-size: 0.7rem;
}
.Backroom__Button--small {
  font-size: 0.825rem;
}
.Backroom__Button--medium {
  font-size: 1rem;
}
.Backroom__Button--large {
  font-size: 1.25rem;
}
.Backroom__Button--huge {
  font-size: 1.5rem;
}
.Backroom__Button:disabled {
  filter: grayscale(1);
  opacity: 0.6;
  pointer-events: none;
}

.Backroom__Buttons {
  display: flex;
  flex-wrap: wrap;
  align-items: center;
  gap: 0.5rem;
  margin: 1rem 0;
}

.Backroom__Table__Wrapper {
  margin: 0 -1rem;
}

.Backroom__Table__Row--red {
  background: var(--BackroomRedBackground);
}

.Backroom__Table {
  /*display: grid;*/
}
.Backroom__Table tr {
  /*display: contents;*/
}
.Backroom__Table thead {
  /*display: contents;*/
  position: sticky;
  top: 0;
}
.Backroom__Overlay__Iframe__Html .Backroom__Table thead {
  top: 2.6rem;
}
.Backroom__Table thead tr th {
  text-align: left;
  padding: 0.2rem 0.6rem 0.2rem 0.2rem;
  white-space: nowrap;
  background: var(--BackroomGrey2);
  overflow: hidden;
  text-overflow: ellipsis;
}
.Backroom__Table thead tr th a {
  color: var(--BackroomGrey10);
  text-decoration: underline var(--BackroomGrey6) 0.1rem dotted;
  text-underline-offset: 0.1rem;
}
.Backroom__Table tbody {
  /*display: contents;*/
  overflow: scroll;
}
.Backroom__Table tbody tr td {
  vertical-align: top;
  padding: 0.2rem 0.6rem 0.2rem 0.2rem;
  overflow: hidden;
  text-overflow: ellipsis;
}
.Backroom__Table tbody tr + tr {
  border-top: 1px solid var(--BackroomGrey1);
}
.Backroom__Table tfoot {
  /*display: contents;*/
  position: sticky;
  bottom: 0;
  left: 0;
}
.Backroom__Table tfoot tr td {
  background: var(--BackroomGrey2);
}
.Backroom__Table .Backroom__Table__Cell__left {
  text-align: left;
}
.Backroom__Table .Backroom__Table__Cell__right {
  text-align: right;
}
.Backroom__Table .Backroom__Table__Cell__center {
  text-align: center;
}

.Backroom__Pagination {
  background: var(--BackroomGrey2);
  display: flex;
  justify-content: space-between;
  /*max-width: calc(100vw - var(--scrollbarWidth));*/
}
.Backroom__Pagination a {
  display: block;
  padding: 0.55rem 0.7rem;
  line-height: 1;
}
.Backroom__Pagination a:hover {
  background: var(--BackroomGrey3);
}
.Backroom__Pagination .Backroom__Pagination__Page--current a {
  background: var(--BackroomGrey0);
}

.Backroom__Pagination__Previous,
.Backroom__Pagination__Next {
  display: flex;
  white-space: nowrap;
}

.Backroom__Pagination__Pages {
  display: flex;
  justify-content: center;
}

.Backroom__Pagination__Dots {
  font-weight: bold;
  padding: 0.3rem 0;
  line-height: 1;
  color: var(--BackroomGrey8);
}

.Backroom__Table__Icon {
  white-space: nowrap;
  vertical-align: middle;
  padding-top: 0 !important;
  padding-bottom: 0 !important;
}

.Backroom__Button--table,
.Backroom__Button--inline {
  color: var(--BackroomGrey7);
  display: flex;
  gap: 0.4rem;
  align-items: center;
  margin: 0.2rem 0;
  font-size: 0.8em;
}
.Backroom__Button--table .Backroom__Icon,
.Backroom__Button--inline .Backroom__Icon {
  font-size: 1.65em;
}

.Backroom__Overlay {
  position: fixed;
  height: 100vh;
  width: 100vw;
  top: 0;
  left: 0;
  background: rgba(0, 0, 0, 0.5);
  backdrop-filter: blur(3px);
  display: flex;
  align-items: center;
  justify-content: center;
}

.Backroom__Overlay__Iframe {
  border: 0;
  display: block;
  max-width: 95vw;
  max-height: 95vh;
  width: 35rem;
  height: 10rem;
  opacity: 0;
}

.Backroom__Overlay__Iframe--page {
  width: 95vw;
  height: 95vh;
}

.Backroom__Overlay__Iframe--form {
  width: 95vw;
  max-width: 60rem;
  max-height: 95vh;
}

.Backroom__Overlay__Iframe--prompt {
  width: 95vw;
  max-width: 40rem;
  max-height: 95vh;
}

.Backroom__Overlay__Iframe__Html {
  overflow: auto;
  background: white;
}
.Backroom__Overlay__Iframe__Html body {
  display: block;
}

.Backroom__Overlay__Top {
  background: var(--BackroomGrey2);
  position: sticky;
  top: 0;
  left: 0;
  height: 2.6rem;
  display: flex;
  align-items: center;
  justify-content: space-between;
  z-index: 1;
  border-bottom: 1px solid var(--BackroomGrey3);
}

.Backroom__Overlay__Title {
  padding: 0 1rem;
  font-size: 1.1rem;
  font-weight: 800;
  letter-spacing: 1px;
  white-space: nowrap;
}
.Backroom__Overlay__Title em {
  font-size: 0.9rem;
  font-weight: normal;
  letter-spacing: 0;
}

.Backroom__Overlay__Buttons {
  padding-right: 0.5rem;
}

.Backroom__Overlay__Close {
  font-size: 2rem;
  padding: 0 0.5rem;
  text-decoration: none;
}

.Backroom__Overlay__Content {
  padding: 0 1rem;
  /*width: min-content;*/
}

.Backroom__Overlay__Loading {
  position: absolute;
  top: calc(50% - 2.5rem);
  left: calc(50% - 2.5rem);
  width: 5rem;
  height: 5rem;
  color: white;
  animation-name: spin;
  animation-duration: 3000ms;
  animation-iteration-count: infinite;
  animation-timing-function: linear;
}
.Backroom__Overlay__Loading:after {
  font-family: "Font Awesome 6 Free", fantasy;
  content: "\f110";
  font-size: 5rem;
}

@keyframes spin {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}
.Backroom__Sortable {
  background: var(--BackroomGrey1);
  padding: 0.3rem;
  margin: 0 2rem 0 -0.3rem;
  display: flex;
  flex-wrap: wrap;
  gap: 0.3rem;
  min-width: 14rem;
  min-height: 2.1rem;
  flex-direction: column;
}
.Backroom__Sortable > li {
  box-sizing: border-box;
  border: 1px solid var(--BackroomGrey8);
  background: var(--BackroomGrey0);
  padding: 0.2rem 0.4rem;
  min-width: 14rem;
  cursor: pointer;
  position: relative;
}
.Backroom__Sortable .sortable-ghost {
  opacity: 0.1;
}

.Backroom__Sortable--compact {
  padding: 0;
  margin: 0;
  min-height: 1.8rem;
}

.Backroom__Sortable li em {
  color: var(--BackroomGrey5);
}

.Backroom__Sortable__Heading {
  font-size: 1rem;
  color: var(--BackroomGrey9);
  padding-left: 0.6rem;
  margin-bottom: 0.3rem;
}

.Backroom__Sortable--grid {
  flex-direction: row;
  min-width: 0;
}
.Backroom__Sortable--grid > li {
  min-width: 0;
  width: 14rem;
}

.Backroom__Sortable li .Backroom__Sortable__Trash {
  display: flex;
  align-items: center;
  position: absolute;
  left: 100%;
  top: 0;
  bottom: 0;
  font-size: 1.2rem;
  padding: 0.5rem;
  margin-left: 0.5rem;
  opacity: 0.5;
}
.Backroom__Sortable li .Backroom__Sortable__Trash > * {
  pointer-events: none;
}

.Backroom__Sortable--compact li .Backroom__Sortable__Trash {
  left: auto;
  right: 0;
}

.Backroom__Sortable li .Backroom__Sortable__Trash:hover {
  opacity: 1;
}
